searchData={"items":[{"type":"behaviour","title":"EppoSdk.AssignmentLogger","doc":"Behaviour for logging experiment assignments.","ref":"EppoSdk.AssignmentLogger.html"},{"type":"function","title":"EppoSdk.AssignmentLogger.log_assignment/1","doc":"Default implementation that does nothing.","ref":"EppoSdk.AssignmentLogger.html#log_assignment/1"},{"type":"callback","title":"EppoSdk.AssignmentLogger.log_assignment/1","doc":"","ref":"EppoSdk.AssignmentLogger.html#c:log_assignment/1"},{"type":"module","title":"EppoSdk.Client","doc":"Client for interacting with Eppo feature flags and experiments.\n\nProvides methods to evaluate feature flags and experiments for subjects based on\ntargeting rules and randomization. Supports string and JSON value assignments with\noptional evaluation details.","ref":"EppoSdk.Client.html"},{"type":"module","title":"Configuration - EppoSdk.Client","doc":"The client is configured using `EppoSdk.Client.Config`:\n\n- api_key: SDK API key for authentication (Can be configured in the [Eppo SDK keys page](https://eppo.cloud/configuration/environments/keys))\n- assignment_logger: Module for logging assignments (implements EppoSdk.AssignmentLogger)\n- is_graceful_mode: Whether to fail gracefully on errors (default: true)\n- poll_interval_seconds: Interval between config polls in seconds (default: 30)\n- poll_jitter_seconds: Random jitter added to poll interval (default: 3)\n- base_url: Base URL for the Eppo API (default: https://fscdn.eppo.cloud/api)","ref":"EppoSdk.Client.html#module-configuration"},{"type":"module","title":"Usage - EppoSdk.Client","doc":"","ref":"EppoSdk.Client.html#module-usage"},{"type":"module","title":"Initialization - EppoSdk.Client","doc":"To create a new client, use the `new/1` function with a `Config` struct:\n\n```elixir\nconfig = %EppoSdk.Client.Config{api_key: \"your-api-key\", assignment_logger: YourApp.AssignmentLogger}\n{:ok, client} = EppoSdk.Client.new(config)\n```","ref":"EppoSdk.Client.html#module-initialization"},{"type":"module","title":"Evaluating Feature Flags - EppoSdk.Client","doc":"Use the client to evaluate feature flags and experiments for subjects:\n\n```elixir\nassignment = EppoSdk.Client.get_string_assignment(\n  client,\n  \"flag-key\",\n  \"user-123\",\n  %{\"country\" => \"US\", \"age\" => 25},\n  \"default\")\n```\nNote that these functions will never return an error or nil value.\nWhen an error occurs, the client will return the default value.","ref":"EppoSdk.Client.html#module-evaluating-feature-flags"},{"type":"module","title":"Debugging with get_assignment_details - EppoSdk.Client","doc":"To get more information about the assignment, you can use get_assignment_details functions.\nThese functions return a tuple with the assignment value and a map of additional details.\nThis is less efficient than using the get_assignment functions, and should only be used for debugging.\n\n```elixir\n{value, details} = EppoSdk.Client.get_string_assignment_details(\n  client,\n  \"flag-key\",\n  \"user-123\",\n  %{\"country\" => \"US\", \"age\" => 25},\n  \"default\")\n```","ref":"EppoSdk.Client.html#module-debugging-with-get_assignment_details"},{"type":"function","title":"EppoSdk.Client.get_boolean_assignment/5","doc":"Assigns a boolean variant based on the provided flag configuration.","ref":"EppoSdk.Client.html#get_boolean_assignment/5"},{"type":"function","title":"Parameters - EppoSdk.Client.get_boolean_assignment/5","doc":"- flag_key: Identifies which set of configuration rules to use\n  - subject_key: Unique identifier for the subject (usually a user ID)\n  - subject_attributes: Optional key-value pairs for rule evaluation\n  - default: Fallback value if assignment fails\n\n```elixir\nassignment = EppoSdk.Client.get_boolean_assignment(\n  client,\n  \"flag-key\",\n  \"user-123\",\n  %{\"country\" => \"US\", \"age\" => 25},\n  false)\n```","ref":"EppoSdk.Client.html#get_boolean_assignment/5-parameters"},{"type":"function","title":"EppoSdk.Client.get_boolean_assignment_details/5","doc":"Like get_boolean_assignment/4 but returns additional evaluation details.\nReturns {value, details} tuple.","ref":"EppoSdk.Client.html#get_boolean_assignment_details/5"},{"type":"function","title":"EppoSdk.Client.get_integer_assignment/5","doc":"Assigns an integer variant based on the provided flag configuration.","ref":"EppoSdk.Client.html#get_integer_assignment/5"},{"type":"function","title":"Parameters - EppoSdk.Client.get_integer_assignment/5","doc":"- flag_key: Identifies which set of configuration rules to use\n  - subject_key: Unique identifier for the subject (usually a user ID)\n  - subject_attributes: Optional key-value pairs for rule evaluation\n  - default: Fallback value if assignment fails\n\n```elixir\nassignment = EppoSdk.Client.get_integer_assignment(\n  client,\n  \"flag-key\",\n  \"user-123\",\n  %{\"country\" => \"US\", \"age\" => 25},\n  10)\n```","ref":"EppoSdk.Client.html#get_integer_assignment/5-parameters"},{"type":"function","title":"EppoSdk.Client.get_integer_assignment_details/5","doc":"Like get_integer_assignment/4 but returns additional evaluation details.\nReturns {value, details} tuple.","ref":"EppoSdk.Client.html#get_integer_assignment_details/5"},{"type":"function","title":"EppoSdk.Client.get_json_assignment/5","doc":"Assigns a JSON variant based on the provided flag configuration.\nReturns a Map","ref":"EppoSdk.Client.html#get_json_assignment/5"},{"type":"function","title":"Parameters - EppoSdk.Client.get_json_assignment/5","doc":"- flag_key: Identifies which set of configuration rules to use\n  - subject_key: Unique identifier for the subject (usually a user ID)\n  - subject_attributes: Optional key-value pairs for rule evaluation\n  - default: Fallback Map if assignment fails\n\n\n```elixir\nassignment = EppoSdk.Client.get_json_assignment(\n  client,\n  \"flag-key\",\n  \"user-123\",\n  %{\"country\" => \"US\", \"age\" => 25},\n  %{\"default\" => \"value\"})\n```","ref":"EppoSdk.Client.html#get_json_assignment/5-parameters"},{"type":"function","title":"EppoSdk.Client.get_json_assignment_details/5","doc":"Like get_json_assignment/4 but returns additional evaluation details.\nReturns `{value, details}` tuple.","ref":"EppoSdk.Client.html#get_json_assignment_details/5"},{"type":"function","title":"EppoSdk.Client.get_numeric_assignment/5","doc":"Assigns a numeric (float) variant based on the provided flag configuration.","ref":"EppoSdk.Client.html#get_numeric_assignment/5"},{"type":"function","title":"Parameters - EppoSdk.Client.get_numeric_assignment/5","doc":"- flag_key: Identifies which set of configuration rules to use\n  - subject_key: Unique identifier for the subject (usually a user ID)\n  - subject_attributes: Optional key-value pairs for rule evaluation\n  - default: Fallback value if assignment fails\n\n```elixir\nassignment = EppoSdk.Client.get_numeric_assignment(\n  client,\n  \"flag-key\",\n  \"user-123\",\n  %{\"country\" => \"US\", \"age\" => 25},\n  3.14159)\n```","ref":"EppoSdk.Client.html#get_numeric_assignment/5-parameters"},{"type":"function","title":"EppoSdk.Client.get_numeric_assignment_details/5","doc":"Like get_numeric_assignment/4 but returns additional evaluation details.\nReturns {value, details} tuple.","ref":"EppoSdk.Client.html#get_numeric_assignment_details/5"},{"type":"function","title":"EppoSdk.Client.get_string_assignment/5","doc":"Assigns a string variant based on the provided flag configuration.","ref":"EppoSdk.Client.html#get_string_assignment/5"},{"type":"function","title":"Parameters - EppoSdk.Client.get_string_assignment/5","doc":"- flag_key: Identifies which set of configuration rules to use\n  - subject_key: Unique identifier for the subject (usually a user ID)\n  - subject_attributes: Optional key-value pairs for rule evaluation\n  - default: Fallback value if assignment fails\n\n\n```elixir\nassignment = EppoSdk.Client.get_string_assignment(\n  client,\n  \"flag-key\",\n  \"user-123\",\n  %{\"country\" => \"US\", \"age\" => 25},\n  \"default\")\n```","ref":"EppoSdk.Client.html#get_string_assignment/5-parameters"},{"type":"function","title":"EppoSdk.Client.get_string_assignment_details/5","doc":"Like get_string_assignment/4 but returns additional evaluation details.\nReturns `{value, details}` tuple.\n\n```elixir\n{value, details} = EppoSdk.Client.get_string_assignment_details(\n  client,\n  \"flag-key\",\n  \"user-123\",\n  %{\"country\" => \"US\", \"age\" => 25},\n  \"default\")\n```","ref":"EppoSdk.Client.html#get_string_assignment_details/5"},{"type":"function","title":"EppoSdk.Client.new/1","doc":"Creates a new Eppo client for evaluating feature flags.\n\nTakes a Config struct and returns {:ok, client} on success or {:error, reason} on failure.\n\n```elixir\n{:ok, client} = EppoSdk.Client.new(config)\n```","ref":"EppoSdk.Client.html#new/1"},{"type":"function","title":"EppoSdk.Client.wait_for_initialization/2","doc":"Waits for client to fetch configuration and get ready to serve\nassignments.\n\nThis method blocks the current thread until configuration is\nsuccessfully fetched or `timeout_seconds` passes.","ref":"EppoSdk.Client.html#wait_for_initialization/2"},{"type":"function","title":"Parameters - EppoSdk.Client.wait_for_initialization/2","doc":"- timeout_seconds: Timeout in seconds (default: 1.0)","ref":"EppoSdk.Client.html#wait_for_initialization/2-parameters"},{"type":"function","title":"Usage - EppoSdk.Client.wait_for_initialization/2","doc":"```elixir\nEppoSdk.Client.wait_for_initialization(client, 2.0)\n```","ref":"EppoSdk.Client.html#wait_for_initialization/2-usage"},{"type":"module","title":"EppoSdk.Client.Config","doc":"Configuration for the Eppo client.","ref":"EppoSdk.Client.Config.html"},{"type":"module","title":"Fields - EppoSdk.Client.Config","doc":"- api_key: Required API key for authentication\n  - assignment_logger: Optional module implementing EppoSdk.AssignmentLogger for tracking assignments\n  - is_graceful_mode: Whether to fail gracefully on errors (default: true)\n  - poll_interval_seconds: Interval between config polls in seconds (default: 30)\n  - poll_jitter_seconds: Random jitter added to poll interval (default: 3)\n  - base_url: Base URL for the Eppo API (default: https://fscdn.eppo.cloud/api)","ref":"EppoSdk.Client.Config.html#module-fields"},{"type":"module","title":"EppoSdk.Core","doc":"Defines the interface with the Rust core SDK for evaluating feature flags.\n\nThis module provides the core functionality for feature flag evaluation by interfacing\nwith the Rust implementation via NIFs. It handles initialization of the client and\nassignment evaluation while abstracting away the underlying Rust implementation details.","ref":"EppoSdk.Core.html"},{"type":"opaque","title":"EppoSdk.Core.client/0","doc":"","ref":"EppoSdk.Core.html#t:client/0"},{"type":"function","title":"EppoSdk.Core.get_assignment/5","doc":"","ref":"EppoSdk.Core.html#get_assignment/5"},{"type":"function","title":"EppoSdk.Core.get_assignment_details/5","doc":"","ref":"EppoSdk.Core.html#get_assignment_details/5"},{"type":"function","title":"EppoSdk.Core.init/1","doc":"","ref":"EppoSdk.Core.html#init/1"},{"type":"function","title":"EppoSdk.Core.wait_for_initialization/2","doc":"","ref":"EppoSdk.Core.html#wait_for_initialization/2"},{"type":"module","title":"EppoSdk.Core.Config","doc":"","ref":"EppoSdk.Core.Config.html"},{"type":"module","title":"EppoSdk.Server","doc":"A GenServer that maintains a singleton Eppo SDK client instance for querying feature flags.\n\nThe server can be started directly:\n\n    config = %EppoSdk.Client.Config{\n      api_key: api_key,\n      assignment_logger: EppoSdk.AssignmentLogger,\n      is_graceful_mode: true,\n      poll_interval_seconds: 30,\n      poll_jitter_seconds: 3\n    }\n\n    {:ok, _pid} = EppoSdk.Server.start_link(config)\n    client = EppoSdk.Server.get_instance()\n\nOr added to your application's supervision tree:\n\n    # In your application.ex\n    defmodule YourApp.Application do\n      use Application\n\n      def start(_type, _args) do\n        config = %EppoSdk.Client.Config{\n          api_key: System.get_env(\"EPPO_API_KEY\"),\n          assignment_logger: YourApp.AssignmentLogger,\n          # ... other config options ...\n        }\n\n        children = [\n          # ... other children ...\n          {EppoSdk.Server, config}\n        ]\n\n        opts = [strategy: :one_for_one, name: YourApp.Supervisor]\n        Supervisor.start_link(children, opts)\n      end\n    end","ref":"EppoSdk.Server.html"},{"type":"function","title":"EppoSdk.Server.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"EppoSdk.Server.html#child_spec/1"},{"type":"function","title":"EppoSdk.Server.get_instance/0","doc":"Returns the singleton client instance.\nThe Server must be started (typically in the consuming application's supervision tree).\n\nReturns client struct or raises if client is not initialized.","ref":"EppoSdk.Server.html#get_instance/0"},{"type":"function","title":"EppoSdk.Server.start_link/1","doc":"","ref":"EppoSdk.Server.html#start_link/1"},{"type":"extras","title":"EppoSdk","doc":"# EppoSdk\n\n[Eppo](https://www.geteppo.com/) is a modular flagging and experimentation analysis tool.\nBefore proceeding you'll need an Eppo account.","ref":"readme.html"},{"type":"extras","title":"Features - EppoSdk","doc":"- Feature gates\n- Kill switches\n- Progressive rollouts\n- A/B/n experiments\n- Mutually exclusive experiments (Layers)\n- Holdouts\n- Contextual multi-armed bandits\n- Dynamic configuration","ref":"readme.html#features"},{"type":"extras","title":"Installation - EppoSdk","doc":"Add `eppo_sdk` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:eppo_sdk, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - EppoSdk","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Setup - EppoSdk","doc":"Add the Eppo Client Server to your application's supervision tree:\n\n```elixir\n# In your application.ex\ndefmodule YourApp.Application do\n  use Application\n\n  def start(_type, _args) do\n    config = %EppoSdk.Client.Config{\n      api_key: System.get_env(\"EPPO_API_KEY\"),\n      assignment_logger: YourApp.AssignmentLogger,\n      # ... other config options ...\n    }\n\n    children = [\n      # ... other children ...\n      {Eppo.Server, config}\n    ]\n\n    opts = [strategy: :one_for_one, name: YourApp.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```","ref":"readme.html#setup"},{"type":"extras","title":"Implementing an Assignment Logger - EppoSdk","doc":"The assignment logger is used to track experiment assignments for analytics. Implement the `Eppo.AssignmentLogger` behaviour in your application:\n\n```elixir\ndefmodule YourApp.AssignmentLogger do\n  @behaviour Eppo.AssignmentLogger\n\n  @impl true\n  def log_assignment(event) do\n    # Implement your logging logic here\n    IO.inspect(event, label: \"log_assignment\")\n  end\nend\n```","ref":"readme.html#implementing-an-assignment-logger"},{"type":"extras","title":"Using the Client - EppoSdk","doc":"Once the server is started, you can access the client instance anywhere in your application:\n\n```elixir\n# Get the client instance\nclient = Eppo.Server.get_instance()\n\n# Use the client to evaluate feature flags\nassignment = EppoSdk.Client.get_string_assignment(\n  client,\n  \"flag-key\",\n  \"user-123\",\n  %{},\n  \"default\"\n)\n```","ref":"readme.html#using-the-client"},{"type":"extras","title":"Manual Start (e.g., for testing) - EppoSdk","doc":"If you need to start the server manually (not recommended for production):\n\n```elixir\nconfig = %EppoSdk.Client.Config{api_key: \"your-api-key\", assignment_logger: YourApp.AssignmentLogger}\n{:ok, _pid} = EppoSdk.Server.start_link(config)\n\n# When testing locally, wait for the client to initialize\nclient = EppoSdk.Server.get_instance()\nEppoSdk.Client.wait_for_initialization(client)\n\n# Then use as normal\nclient = EppoSdk.Server.get_instance()\n```\n\nOr you can use the client directly:\n```elixir\n{:ok, client} = EppoSdk.Client.new(config)\n\n# When testing locally, wait for the client to initialize\nEppoSdk.Client.wait_for_initialization(client)\n```","ref":"readme.html#manual-start-e-g-for-testing"},{"type":"extras","title":"Local Development with eppo_core - EppoSdk","doc":"When developing the Elixir SDK alongside eppo_core, you can configure Cargo to use the local eppo_core package instead of the published version:\n\n1. Copy the template configuration file:\n   ```bash\n   cp .cargo/config.toml.template .cargo/config.toml\n   ```\n\n2. This will configure Cargo to use the local eppo_core package located at `../eppo_core` relative to the elixir-sdk directory.\n\n3. Compile the SDK to use your local eppo_core version:\n   ```bash\n   mix compile\n   ```\n\n4. Any changes to the local eppo_core package will now be reflected when you recompile the Elixir SDK.\n\nFor publishing releases, make sure to:\n1. Test with the published eppo_core version (remove the .cargo/config.toml)\n2. Ensure the version in native/sdk_core/Cargo.toml matches the published eppo_core version","ref":"readme.html#local-development-with-eppo_core"},{"type":"extras","title":"Testing - EppoSdk","doc":"To run the tests:\n```bash\nmix test\n```","ref":"readme.html#testing"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2024 Eppo\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}